PART 10: CONNECTED COMPONENTS
*****************************

FILES
-----

Makefile
doc/README.CC
pdf/ConnectedComponents.pdf
lhs/Algos/Graphs/ConnectedComponents.lhs
hs/Algos/DivideAndConquer/Sorting.hs
hs/Algos/DS/Dict.hs
hs/Algos/DS/Stack.hs
hs/Algos/Graphs/CCGen.hs
hs/Algos/Graphs/CCMain.hs
hs/Algos/Graphs/CCVerify.hs
hs/Algos/Graphs/ConnectedComponents.hs
hs/Algos/Graphs/DFS.hs
hs/Algos/Graphs/Forest.hs
hs/Algos/Graphs/Graph.hs
hs/Algos/Graphs/GraphIO.hs
hs/Algos/Graphs/Traversal.hs
hs/Algos/Random/Impl.hs
hs/Algos/Random/Numbers.hs
hs/Algos/Random/Partitions.hs
hs/Algos/Random/Sequences.hs
hs/Algos/Random/Sets.hs

DESCRIPTION
-----------

This module provides an implementation of computing the connected components of
a graph, including a test data generator and a verification program that verifies
the output of the algorithm.

To compile these programs, run

    make programs/CC
    make programs/CCGen
    make programs/CCVerify

Then, to generate a test graph and a file containing the expected connected components, run

    programs/CCGen <n> <m> <# components> <graph file> <expected components file>

To compute the connected components of the graph, run

    programs/CC <graph file> <components file>

To test whether the computed components are correct, run

    programs/CCVerify <components file> <expected components file>

To (re)generate the PDF file from the source, run

    make pdf/ConnectedComponents.pdf
