{-# LINE 30 "DFS.lhs" #-}
  module Algos.Graphs.DFS ( dfs
                          ) where
 
  import Algos.DS.Stack (Stack,emptyStack,push,pop,top)
  import Algos.Graphs.Forest (Forest)
  import Algos.Graphs.Graph (AdjList,V,E,vIx)
  import Algos.Graphs.Traversal (VertexSet(..),traverse)
  import Control.Applicative ((<$>),(<*>))
  import Control.Monad.ST (ST)
  import Data.Array.ST (STArray,newArray,readArray,writeArray)
  import Data.STRef (STRef,newSTRef,modifySTRef,readSTRef,writeSTRef)
{-# LINE 54 "DFS.lhs" #-}
  dfs :: AdjList v vl el -> Forest V E
{-# LINE 59 "DFS.lhs" #-}
  dfs = traverse makeVertexStack
{-# LINE 65 "DFS.lhs" #-}
  data VertexStack s = VertexStack (STArray s Int Bool) (STRef s (Stack (V,[(E,V)])))
{-# LINE 71 "DFS.lhs" #-}
  makeVertexStack    ::  Int -> ST s (VertexStack s)
  makeVertexStack n  =   VertexStack <$> newArray (1,n) False <*> newSTRef emptyStack
{-# LINE 77 "DFS.lhs" #-}
  instance VertexSet VertexStack where
 
    add (VertexStack _   st) v p = modifySTRef st (flip push (v,p))
{-# LINE 82 "DFS.lhs" #-}
    remove (VertexStack exp st) = readSTRef st >>= rem
      where  rem s = case top s of
                       Nothing       ->  writeSTRef st s >> return Nothing
                       Just p@(v,_)  ->  do  e <- readArray exp (vIx v)
                                             if e  then  rem (pop s)
                                                   else  do  writeSTRef st (pop s)
                                                             writeArray exp (vIx v) True
                                                             return (Just p)
